> This page is for version Legacy.
> For other versions, use one of these documentation indexes:
> - 2024-10-01 (default): https://docs.getkard.com/2024-10-01/llms.txt
> - Legacy: https://docs.getkard.com/legacy/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.getkard.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getkard.com/_mcp/server.

# Create Attribution Events

POST https://rewards-api.getkard.com/issuers/{organizationId}/attributions
Content-Type: application/json

Call this endpoint to send all attribution events made by all enrolled users in your rewards program. These attribution events will be processed by the Kard system.
Required scopes: `attributions.write`

Reference: https://docs.getkard.com/api/attributions/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://rewards-api.getkard.com` (Production, default)
- `https://test-rewards-api.getkard.com` (Sandbox)

## Request

### Path parameters

- `organizationId` (string, required) — Your organization ID, provided by Kard.

### Headers

- `X-Kard-organizationId` (string, optional)

### Body (application/json)

This endpoint expects a CreateAttributionRequestBody.

- `data` (list of CreateAttributesRequest, required) — Data and attributes related to the attribution event.

## Response

### 200

- `string`

## Errors

### 401 Unauthorized Error

- `message` (string, required)

### 500 Internal Server Error

- `string`

### 400 Invalid Request

- `InvalidRequestUnion`

## Types

### CreateAttributesRequest

- `type` (enum, required)
  - Allowed values: `attribution`
- `attributes` (Attributes, required)

### RequestValidationErrorResponse

- `errors` (list of string, required)

### Attributes

- `userId` (string, required) — The referring partner user ID associated with the attribution event.
- `type` (enum, required) — What the attribution event is on.
  - Allowed values: `OFFER`, `NOTIFICATION`
- `subtype` (enum, required) — The type of attribution event.
  - Allowed values: `IMPRESSION`, `VIEW`
- `typeId` (string, required) — The ID in Kard’s system associated with what the attribution event is on. If `type` is `OFFER`, `typeId` should be the associated offer ID in Kard’s system.
- `medium` (enum, optional) — Where the attribution event is taking place in your rewards experience.
  - Allowed values: `BROWSE`, `MAP`, `SEARCH`, `PUSH`

## Examples

**Request**

```json
{
  "data": [
    {
      "type": "attribution",
      "attributes": {
        "userId": "123",
        "type": "OFFER",
        "subtype": "VIEW",
        "typeId": "60e4ba1da31c5a22a144c075",
        "medium": "SEARCH"
      }
    }
  ]
}
```

**Response**

```json
"OK"
```

**SDK Code**

```python
import requests

url = "https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions"

payload = { "data": [
        {
            "type": "attribution",
            "attributes": {
                "userId": "123",
                "type": "OFFER",
                "subtype": "VIEW",
                "typeId": "60e4ba1da31c5a22a144c075",
                "medium": "SEARCH"
            }
        }
    ] }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":[{"type":"attribution","attributes":{"userId":"123","type":"OFFER","subtype":"VIEW","typeId":"60e4ba1da31c5a22a144c075","medium":"SEARCH"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions"

	payload := strings.NewReader("{\n  \"data\": [\n    {\n      \"type\": \"attribution\",\n      \"attributes\": {\n        \"userId\": \"123\",\n        \"type\": \"OFFER\",\n        \"subtype\": \"VIEW\",\n        \"typeId\": \"60e4ba1da31c5a22a144c075\",\n        \"medium\": \"SEARCH\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": [\n    {\n      \"type\": \"attribution\",\n      \"attributes\": {\n        \"userId\": \"123\",\n        \"type\": \"OFFER\",\n        \"subtype\": \"VIEW\",\n        \"typeId\": \"60e4ba1da31c5a22a144c075\",\n        \"medium\": \"SEARCH\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": [\n    {\n      \"type\": \"attribution\",\n      \"attributes\": {\n        \"userId\": \"123\",\n        \"type\": \"OFFER\",\n        \"subtype\": \"VIEW\",\n        \"typeId\": \"60e4ba1da31c5a22a144c075\",\n        \"medium\": \"SEARCH\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions', [
  'body' => '{
  "data": [
    {
      "type": "attribution",
      "attributes": {
        "userId": "123",
        "type": "OFFER",
        "subtype": "VIEW",
        "typeId": "60e4ba1da31c5a22a144c075",
        "medium": "SEARCH"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": [\n    {\n      \"type\": \"attribution\",\n      \"attributes\": {\n        \"userId\": \"123\",\n        \"type\": \"OFFER\",\n        \"subtype\": \"VIEW\",\n        \"typeId\": \"60e4ba1da31c5a22a144c075\",\n        \"medium\": \"SEARCH\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    [
      "type": "attribution",
      "attributes": [
        "userId": "123",
        "type": "OFFER",
        "subtype": "VIEW",
        "typeId": "60e4ba1da31c5a22a144c075",
        "medium": "SEARCH"
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rewards-api.getkard.com/issuers/%7BorganizationId%7D/attributions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```